# Gbase8s中的CLOB数据迁移

Note:

- Gbase8s中可以存储大文本对象clob,最大可以支持4T
- 对于CLOB数据,不好直接导出,需要特殊的方式来处理.



导出clob数据到文件:

```sql
-- 测试表:
create table t_user1(
    f_userid int, 
    f_username varchar(20),
    f_attachment clob
)  put f_attachment in (sbspace1);

-- 先导出其他字段:
unload to 'user_data/user1.txt' select f_userid, f_username, null as f_photo from t_user1;

-- 再处理clob
select lotofile(f_attachment, concat(concat('user_clob/', f_username), '.txt!'), 'client') from t_user1;

-- 导入数据
load from 'user_data/user1.txt' insert into t_user2;

-- 使用文件更新表中的clob字段
 update t_user2 set f_attachment = filetoclob(concat(concat('user_clob/', f_username), '.txt'), 'client');
```

注意：在导出文件命名时，要以!进行结尾，不然GBase 8s会自动在文件名后加上后缀，以防止文件重名。